<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:stsuuser="urn:ibm:names:ITFIM:1.0:stsuuser" version="1.0">

	<xsl:strip-space elements="*" />
	<xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes" />

	<!--
		Initially we start with a copy of the document.
	-->
	<xsl:template match="@* | node()">
		<xsl:copy>
			<xsl:apply-templates select="@* | node()" />
		</xsl:copy>
	</xsl:template>


	<!--
		Delete any existing AttributeList.
	-->
	<xsl:template match="//stsuuser:AttributeList">
	</xsl:template>



	<!--
		This template replaces the entire Principal element with one that contains 
		just a hard coded username. We also add an AttributeList here, which should be the
            only AttributeList since we tried to delete any existing AttributeList above.
	-->
	<xsl:template match="//stsuuser:Principal">
		<stsuuser:Principal>
			<stsuuser:Attribute name="name">
				<stsuuser:Value>wssm-testuser</stsuuser:Value>
			</stsuuser:Attribute>
			<stsuuser:Attribute name="issuer" type="urn:oasis:names:tc:SAML:2.0:assertion">
				<stsuuser:Value>http://mycompany.com</stsuuser:Value>
			</stsuuser:Attribute>
		</stsuuser:Principal>

		<stsuuser:AttributeList>
			<!-- The "real" username is extracted from the principal and added as an extended attribute -->
			<stsuuser:Attribute name="real_username" type="wssm_example">
				<stsuuser:Value><xsl:value-of select="//stsuuser:Principal/stsuuser:Attribute[@name='name']/stsuuser:Value/text()"/></stsuuser:Value>
			</stsuuser:Attribute>
		</stsuuser:AttributeList>

	</xsl:template>
</xsl:stylesheet>
